Bug 1690028 - Allow to load libc.so shared library without RTLD_DEEPBIND
Summary: Allow to load libc.so shared library without RTLD_DEEPBIND
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: uid_wrapper
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Andreas Schneider
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-18 15:43 UTC by Lukas Slebodnik
Modified: 2020-02-20 05:03 UTC (History)
3 users (show)

Fixed In Version: uid_wrapper-1.2.7-2.fc31
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-20 05:03:52 UTC
Type: Bug


Attachments (Terms of Use)

Description Lukas Slebodnik 2019-03-18 15:43:44 UTC
Description of problem:
uid_wrapper does not work well with address sanitizer.
(similar case was already solved in nss_wrapper)  

Version-Release number of selected component (if applicable):
sh$ rpm -q uid_wrapper
uid_wrapper-1.2.4-3.fc29.x86_64

How reproducible:
Deterministic

Steps to Reproduce:
1. useradd test
2. dnf install -y uid_wrapper libasan -e0 -d0
3. su - test
4. id -u
5. LD_PRELOAD="/usr/lib64/libasan.so.5:/usr/lib64/libuid_wrapper.so.0" UID_WRAPPER=1 UID_WRAPPER_ROOT=1 id -u

Actual results:
[root@0de714eea153 /]# useradd test
[root@0de714eea153 /]# dnf install -y uid_wrapper libasan -e0 -d0
[root@0de714eea153 /]# su - test
[test@0de714eea153 ~]$ id -u
1000
[test@0de714eea153 ~]$ LD_PRELOAD="/usr/lib64/libasan.so.5:/usr/lib64/libuid_wrapper.so.0" UID_WRAPPER=1 UID_WRAPPER_ROOT=1 id -u
==83==You are trying to dlopen a libc.so.10 shared library with RTLD_DEEPBIND flag which is incompatibe with sanitizer runtime (see https://github.com/google/sanitizers/issues/611 for details). If you want to run libc.so.10 library under sanitizers please remove RTLD_DEEPBIND from dlopen flags.

Expected results:
[root@0de714eea153 /]# useradd test
[root@0de714eea153 /]# dnf install -y uid_wrapper libasan -e0 -d0
[root@0de714eea153 /]# su - test
[test@0de714eea153 ~]$ id -u
1000
[test@0de714eea153 ~]$ LD_PRELOAD="/usr/lib64/libasan.so.5:/usr/lib64/libuid_wrapper.so.0" UID_WRAPPER=1 UID_WRAPPER_ROOT=1 id -u
UID_WRAPPER_ROOT=1 id -u
0

Comment 1 Andreas Schneider 2019-03-18 20:03:57 UTC
I know, I just need to find time to clean up uid_wrapper and that's the problem.

Comment 2 Ben Cotton 2019-05-02 19:46:28 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Ben Cotton 2019-08-13 19:22:12 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 4 Lukas Slebodnik 2020-02-11 10:18:11 UTC
Any progress after (almost) a year?

Comment 5 Andreas Schneider 2020-02-11 15:59:05 UTC
This should be fixes with uid_wrapper 1.2.5. But I haven't packaged it for Fedora yet.

See https://gitlab.com/cwrap/uid_wrapper/-/blob/master/doc/uid_wrapper.1.txt#L67


Will do asap.

Comment 6 Fedora Update System 2020-02-11 16:21:26 UTC
FEDORA-2020-e1fd846400 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-e1fd846400

Comment 7 Fedora Update System 2020-02-12 01:57:33 UTC
uid_wrapper-1.2.7-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-e1fd846400

Comment 8 Fedora Update System 2020-02-12 09:22:52 UTC
FEDORA-2020-fe538be980 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-fe538be980

Comment 9 Fedora Update System 2020-02-12 20:41:23 UTC
uid_wrapper-1.2.7-2.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-fe538be980

Comment 10 Fedora Update System 2020-02-20 05:03:52 UTC
uid_wrapper-1.2.7-2.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.